# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.TeamMembers do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :MemberKeyNumeric,
    :TeamKeyNumeric,
    :TeamMemberKeyNumeric,
    :MemberKey,
    :MemberLoginId,
    :MemberMlsId,
    :OriginatingSystemID,
    :OriginatingSystemKey,
    :OriginatingSystemName,
    :SourceSystemID,
    :SourceSystemKey,
    :SourceSystemName,
    :TeamKey,
    :TeamMemberKey,
    :TeamMemberNationalAssociationId,
    :TeamMemberStateLicense,
    :TeamImpersonationLevel,
    :TeamMemberType,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :Member,
    :OriginatingSystem,
    :SourceSystem
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :MemberKeyNumeric => float() | nil,
    :TeamKeyNumeric => float() | nil,
    :TeamMemberKeyNumeric => float() | nil,
    :MemberKey => String.t | nil,
    :MemberLoginId => String.t | nil,
    :MemberMlsId => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :TeamKey => String.t | nil,
    :TeamMemberKey => String.t | nil,
    :TeamMemberNationalAssociationId => String.t | nil,
    :TeamMemberStateLicense => String.t | nil,
    :TeamImpersonationLevel => String.t | nil,
    :TeamMemberType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :Member => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.TeamMembers do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:Member, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
  end
end

